# -*- coding: utf-8 -*-
from setuphelpers import *
import requests
from bs4 import BeautifulSoup


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    store_id = "9pmz94127m4g"
    res = requests.post(
        "https://store.rg-adguard.net/api/GetFiles",
        "type=ProductId&url=%s&ring=RP&lang=fr-FR" % store_id,
        headers={"content-type": "application/x-www-form-urlencoded"},
        proxies=proxies,
    )
    page = BeautifulSoup.BeautifulSoup(res.content, features="html.parser")
    for bs_search in page.find_all("a"):
        if "FBReader" in bs_search.text and ".msix" in bs_search.text:
            version = bs_search.text.split("_")[1]
            latest_bin = bs_search.text
            download_url = bs_search["href"]
            break

    if download_url.split("/")[2].endswith("microsoft.com"):
        if not isfile(latest_bin):
            print("Downloading: %s" % latest_bin)
            wget(download_url, latest_bin, proxies=proxies)
        else:
            print("Binary file version corresponds to online version")

        if Version(version) > Version(control.get_software_version()):
            print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
            result = True
        else:
            print("Software version up-to-date (%s)" % Version(version))
        control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    else:
        print("ERROR The retrieved url will not download from microsoft's servers")
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating or not update-package-sources
    return result
